// DemoAppView.cpp : implementation of the CDemoAppView class
//

#include "stdafx.h"
#include "DemoApp.h"

#include "DemoAppDoc.h"
#include "DemoAppView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemoAppView

IMPLEMENT_DYNCREATE(CDemoAppView, CView)

BEGIN_MESSAGE_MAP(CDemoAppView, CView)
	//{{AFX_MSG_MAP(CDemoAppView)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoAppView construction/destruction

CDemoAppView::CDemoAppView()
{
	// TODO: add construction code here

}

CDemoAppView::~CDemoAppView()
{
}

BOOL CDemoAppView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDemoAppView drawing

void CDemoAppView::OnDraw(CDC* pDC)
{
	CDemoAppDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CDemoAppView printing

BOOL CDemoAppView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDemoAppView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDemoAppView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDemoAppView diagnostics

#ifdef _DEBUG
void CDemoAppView::AssertValid() const
{
	CView::AssertValid();
}

void CDemoAppView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDemoAppDoc* CDemoAppView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDemoAppDoc)));
	return (CDemoAppDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDemoAppView message handlers

int CDemoAppView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	SetClassLong(m_hWnd, GCL_HBRBACKGROUND,
		(long) CreateSolidBrush(RGB (216,222,231)));

	CreateWndCtrls();

	AddComboCtrls(); 
	AddBtnCtrls();
	AddEditCtrls();
	AddMultiCtrls();
	AddStaticCtrls();

	m_ctrlCombo.AddMenuItem(MF_STRING, 0x9998, "Open Edit WndCtrl");
	m_ctrlCombo.AddMenuItem(MF_STRING, 0x9999, "Close Edit WndCtrl");
	
	return 0;
}

void CDemoAppView::CreateWndCtrls()
{
	HBRUSH hbr;

	m_ctrlCombo.Create("Combo", WS_CHILD | WS_VISIBLE, 0,
						 10,10, this, 0x0001);
	m_ctrlCombo.CreateTitleBrush(216, 222, 231); //to create a title background brush
	m_ctrlCombo.SetOpenWndCtrlStyle(0,WS_EX_STATICEDGE);


	hbr = CreateSolidBrush(RGB(216,222,231)); //same as title background brush


	m_ctrlButtons.Create("Buttons", WS_CHILD | WS_VISIBLE, 0,
						 10,30, this, 0x0002);
	m_ctrlButtons.SetTitleBrush(hbr); //call this member to set a pre-created title brush

	m_ctrlEdit.Create("Edit", WS_CHILD | WS_VISIBLE, 0,
						 10,50, this, 0x0003);
	m_ctrlEdit.SetTitleBrush(hbr);
	m_ctrlEdit.SetOpenWndCtrlStyle(WS_BORDER,0);

	m_ctrlMulti.Create("Mixed", WS_CHILD | WS_VISIBLE, 0,
						 300,10, this, 0x0004);
	m_ctrlMulti.SetTitleBrush(hbr);
	m_ctrlMulti.SetOpenWndCtrlStyle(0,WS_EX_STATICEDGE);

	m_ctrlStatic.Create("Static", WS_CHILD | WS_VISIBLE, 0,
						 452,10, this, 0x0005);
	m_ctrlStatic.SetTitleBrush(hbr);
	m_ctrlStatic.SetOpenWndCtrlStyle(0,WS_EX_STATICEDGE);

/*	m_ctrlListBox.Create("ListBox", WS_CHILD | WS_VISIBLE, 0,
						310,10, this, 0x0006);
	m_ctrlListBox.SetTitleBrush(hbr);
*/
	m_ctrlEmpty.Create("Empty", WS_CHILD | WS_VISIBLE, 0,
						 604,10, this, 0x0007);
	m_ctrlEmpty.SetTitleBrush(hbr);
	m_ctrlEmpty.SetOpenWndCtrlStyle(0,WS_EX_STATICEDGE);
}

void CDemoAppView::AddComboCtrls()
{
	m_ctrlCombo.AddControl(&m_combo, CRect(10,30, 250, 180), "COMBOBOX", "", CBS_DROPDOWN,
							0,0x1001);
	m_ctrlCombo.SetOpenHeight(70);
	m_ctrlCombo.SetOpenWidth(260);
}

void CDemoAppView::AddBtnCtrls()
{
	m_ctrlButtons.AddControl(&m_btn1, CRect(10,30,100,50), "BUTTON", "+ Height", BS_PUSHBUTTON,
							0,0x2001);
	m_ctrlButtons.AddControl(&m_btn2, CRect(150,30,250,50), "BUTTON", "- Height", BS_PUSHBUTTON,
							0,0x2002);

	m_ctrlButtons.SetOpenHeight(70);
	m_ctrlButtons.SetOpenWidth(260);
}

void CDemoAppView::AddMultiCtrls()
{
	m_ctrlMulti.AddControl(&m_multiBtn, CRect(10,60,78,100), "BUTTON", "&Open", BS_PUSHBUTTON,
							0, 0x4001);
	m_ctrlMulti.AddControl(&m_multiEdit, CRect(10,30,250,50), "EDIT", "", ES_LEFT,
							WS_EX_CLIENTEDGE, 0x4002);
	m_ctrlMulti.AddControl(&m_multiList, CRect(80,50,250,240), "LISTBOX", "Sample Text", LBS_MULTICOLUMN | LBS_MULTIPLESEL,
							WS_EX_CLIENTEDGE, 0x4003);
	m_ctrlMulti.AddControl(&m_multiStatic, CRect(10,120,78,240), "STATIC", "Sample Text", SS_LEFT,
							0, 0x4004);

	m_ctrlMulti.SetOpenHeight(250);
	m_ctrlMulti.SetOpenWidth(260);
}

void CDemoAppView::AddEditCtrls()
{
	m_ctrlEdit.AddControl(&m_grpEdit, CRect(10,25,250,240), "BUTTON", "Edit Box", BS_GROUPBOX,
							0, 0x3001);
	m_ctrlEdit.AddControl(&m_edit, CRect(20,45,240,230), "EDIT", "", ES_LEFT | ES_MULTILINE | ES_WANTRETURN | WS_VSCROLL,
							WS_EX_CLIENTEDGE, 0x3002);

	m_ctrlEdit.SetOpenHeight(250);
	m_ctrlEdit.SetOpenWidth(260);
}

void CDemoAppView::AddStaticCtrls()
{
	m_ctrlStatic.AddControl(&m_static1, CRect(10,25,250,45), "STATIC", "Static Control", ES_LEFT,
							0, 0x5001);
	m_ctrlStatic.AddControl(&m_static2, CRect(10,50,250,70), "STATIC", "Static Control", ES_LEFT,
							0, 0x5002);

	m_ctrlStatic.SetOpenHeight(100);
	m_ctrlStatic.SetOpenWidth(260);
}

LRESULT CDemoAppView::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch (message)
	{
	case WCM_RESIZEWND:
		RepositionWnd((HWND)lParam);
		break;

	case WCM_OPENING:
		break;

	case WCM_CLOSING:
		break;
	}

	return CView::DefWindowProc(message, wParam, lParam);
}

void CDemoAppView::RepositionWnd(HWND hWnd)
{
	RECT rect, movVRect, movHRect;
	if ( hWnd == m_ctrlCombo.m_hWnd ) 
	{
		m_ctrlCombo.GetWindowRect(&rect); ScreenToClient(&rect); 
		m_ctrlButtons.GetWindowRect(&movVRect); ScreenToClient(&movVRect); 

		m_ctrlButtons.RepositionWindow( movVRect.left, rect.bottom + 2 );
	}

	else if ( hWnd == m_ctrlButtons.m_hWnd )
	{
		m_ctrlButtons.GetWindowRect(&rect); ScreenToClient(&rect);
		m_ctrlEdit.GetWindowRect(&movVRect); ScreenToClient(&movVRect);

		m_ctrlEdit.RepositionWindow(movVRect.left, rect.bottom + 2 );
	}

	else if ( hWnd == m_ctrlMulti.m_hWnd )
	{
		m_ctrlMulti.GetWindowRect(&rect); ScreenToClient(&rect);
		m_ctrlStatic.GetWindowRect(&movHRect); ScreenToClient(&movHRect);

		m_ctrlStatic.RepositionWindow(rect.right+2, movHRect.top);
	}

	else if ( hWnd == m_ctrlStatic.m_hWnd )
	{
		m_ctrlStatic.GetWindowRect(&rect); ScreenToClient(&rect);
		m_ctrlEmpty.GetWindowRect(&movHRect); ScreenToClient(&movHRect);

		m_ctrlEmpty.RepositionWindow(rect.right+2, movHRect.top);
	}
}



BOOL CDemoAppView::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch ( LOWORD (wParam) )
	{
	case 0x2001:
		m_ctrlButtons.IncrementOpenHeight(10);
		break;

	case 0x2002:
		m_ctrlButtons.IncrementOpenHeight(-10);
		break;

	case 0x9998:
		m_ctrlEdit.OpenWndCtrl();
		break;

	case 0x9999:
		m_ctrlEdit.OpenWndCtrl(false);
		break;
	}
	return CView::OnCommand(wParam, lParam);
}

