// WndCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "DemoApp.h"
#include "WndCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWndCtrl

CWndCtrl::CWndCtrl()
{
	m_aCtrls.RemoveAll();
	m_aCtrls.FreeExtra();

	m_bottom = 300; //default open height of WndCtrl;

	m_bExistControl = false;
	m_bOpen = false;
	m_bStopOpen = false;
	m_bStopClose = false;
	m_bFirstTime = true;

	m_dwOpenStyle = WS_CHILD | WS_VISIBLE;
	m_dwOpenExStyle = 0;

	m_titleBrush = CreateSolidBrush(RGB(200,200,200)); //default brush of title of WndCtrl

	m_font.CreatePointFont(100, "Arial"); //Default font of Title of WndCtrl
}

CWndCtrl::~CWndCtrl()
{
}


BEGIN_MESSAGE_MAP(CWndCtrl, CWnd)
	//{{AFX_MSG_MAP(CWndCtrl)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_CTLCOLOR()
	ON_WM_RBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWndCtrl message handlers

int CWndCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

//	SetClassLong(m_hWnd,GCL_HBRBACKGROUND,(long)CreateSolidBrush(RGB(216,222,231)));

	CString title = lpCreateStruct->lpszName;
	
	m_Open.CreateEx(0,"STATIC","",
		WS_CHILD | WS_VISIBLE | WS_DLGFRAME /* WS_BORDER*/ | SS_BITMAP | SS_CENTERIMAGE,
					 CRect(0,0,40,18),
					 this,0x1001);

	m_Open.SetBitmap(::LoadBitmap((HINSTANCE)GetWindowLong(m_hWnd,GWL_HINSTANCE),MAKEINTRESOURCE(ID_CLOSED)));

	m_Title.CreateEx(0, "STATIC", title,
		WS_CHILD | WS_VISIBLE /*|WS_DLGFRAME */|WS_BORDER | SS_CENTER, 
					 CRect(40,0, 150,18),
					 this,0xffff);
	m_Title.SetFont(&m_font);
	
	return 0;
}

BOOL CWndCtrl::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch (LOWORD(wParam))
	{
	case IDM_OPEN:
		OpenWndCtrl();
		break;

	case IDM_CLOSE:
		OpenWndCtrl(FALSE);
		break;

	default:
		GetParent()->SendMessage(WM_COMMAND, wParam, lParam);
		// Sends the command notifications to the parent window
	}

	return CWnd::OnCommand(wParam, lParam);
}

void CWndCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	WINDOWPLACEMENT wp;

	if ( point.x <= 40 && point.y <= 18){
		if (m_bExistControl) {
			m_hCursor = AfxGetApp()->LoadCursor(IDC_POINTINGHAND);
			m_hPrevCursor = SetCursor(m_hCursor);
		}
		else {
			m_hCursor = AfxGetApp()->LoadCursor(IDC_POINTINGHAND_NOTALLOWED);
			m_hPrevCursor = SetCursor(m_hCursor);
		}

		if (!m_bOpen) {
			if (m_bExistControl) {

				::SendMessage(GetParent()->m_hWnd, WCM_OPENING, 
								(WPARAM)GetWindowLong(m_hWnd,GWL_ID),(LPARAM)m_hWnd);
				if (!m_bStopOpen) {

					::SetWindowLong(m_Open.m_hWnd,GWL_STYLE,
						WS_CHILD | WS_VISIBLE | /*WS_DLGFRAME*/ WS_BORDER | SS_BITMAP | SS_CENTERIMAGE);

					::SetWindowLong(m_Open.m_hWnd,GWL_EXSTYLE, WS_EX_STATICEDGE);

					::SetWindowLong(m_hWnd,GWL_STYLE,m_dwOpenStyle);
					::SetWindowLong(m_hWnd,GWL_EXSTYLE,m_dwOpenExStyle);

					m_Open.SetBitmap(::LoadBitmap((HINSTANCE)GetWindowLong(m_hWnd,GWL_HINSTANCE),
									MAKEINTRESOURCE(ID_OPEN)));
					GetWindowPlacement(&wp);
					
					oldWp = wp;

					wp.rcNormalPosition.bottom = wp.rcNormalPosition.top + m_bottom;
					wp.rcNormalPosition.right = wp.rcNormalPosition.left + m_right;

					SetWindowPlacement(&wp);

					DrawControls();	
					m_bOpen = true;
					::SendMessage(GetParent()->m_hWnd, WCM_OPEN, 
									(WPARAM)GetWindowLong(m_hWnd,GWL_ID),(LPARAM)m_hWnd);
				}
				m_bStopOpen = false;
			}
		} 
		else {
			if (m_bExistControl) {
				::SendMessage(GetParent()->m_hWnd, WCM_CLOSING, 
								(WPARAM)GetWindowLong(m_hWnd,GWL_ID),(LPARAM)m_hWnd);

				if ( !m_bStopClose)
				{

					::SetWindowLong(m_Open.m_hWnd,GWL_STYLE,
						WS_CHILD | WS_VISIBLE | WS_DLGFRAME /* WS_BORDER*/ | SS_BITMAP | SS_CENTERIMAGE);

					::SetWindowLong(m_Open.m_hWnd,GWL_EXSTYLE, 0);

					::SetWindowLong(m_hWnd,GWL_STYLE,WS_CHILD | WS_VISIBLE);
					::SetWindowLong(m_hWnd,GWL_EXSTYLE,0);

					m_Open.SetBitmap(::LoadBitmap((HINSTANCE)GetWindowLong(m_hWnd,GWL_HINSTANCE),
									MAKEINTRESOURCE(ID_CLOSED)));
					SetWindowPlacement(&oldWp);
				
					m_bOpen = false;

					DestroyControls();

					::SendMessage(GetParent()->m_hWnd, WCM_CLOSED, 
									(WPARAM)GetWindowLong(m_hWnd,GWL_ID),(LPARAM)m_hWnd);
				}
				m_bStopClose = false;
			}
		}
	}

	CWnd::OnLButtonDown(nFlags, point);
}

void CWndCtrl::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	if ( point.x >=1 && point.y >= 1 &&  point.x <= 40 && point.y <= 18 && m_bExistControl)
	{
		SetCapture();
		m_hCursor = AfxGetApp()->LoadCursor(IDC_POINTINGHAND);
		m_hPrevCursor = SetCursor(m_hCursor);
	}
	else if ( point.x >= 1 && point.y >=1 && point.x <= 40 && point.y <= 18 && !m_bExistControl) 
	{
		SetCapture();
		m_hCursor = AfxGetApp()->LoadCursor(IDC_POINTINGHAND_NOTALLOWED);
		m_hPrevCursor = SetCursor(m_hCursor);
	}
	else
		ReleaseCapture();

//	CWnd::OnMouseMove(nFlags, point);
}

CWnd* CWndCtrl::GetControl(UINT ctrlID)
{
	if ( m_aCtrls.GetSize() == 0 ) return NULL;
	for (int i=0; i<m_aCtrls.GetSize(); i++ )
	{
		if ( ctrlID == m_aCtrls[i].m_id)
			return m_aCtrls[i].m_CWnd;
	}
	return NULL;
}

UINT CWndCtrl::GetControl(CWnd &cWnd)
{
	if ( m_aCtrls.GetSize() == 0 ) return NULL;
	for (int i=0; i<m_aCtrls.GetSize(); i++ )
	{
		if ( cWnd == *(m_aCtrls[i].m_CWnd))
			return m_aCtrls[i].m_id;
	}
	return NULL;	
}

void CWndCtrl::AddControl(CWnd *cwnd, CRect rect, CString strClass, CString strCaption, DWORD dwStyle, DWORD dwExStyle, UINT id)
{
	sCWnd tempCtrl;
	tempCtrl.m_CWnd = cwnd;
	tempCtrl.m_ControlRect = (RECT)rect;
	tempCtrl.m_strClass = strClass;
	tempCtrl.m_strCaption = strCaption;
	tempCtrl.m_dwStyle = dwStyle;
	tempCtrl.m_dwExStyle = dwExStyle;
	tempCtrl.m_id = id;

	m_aCtrls.Add(tempCtrl);

	m_bExistControl = true;
}

bool CWndCtrl::DrawControls()
{
	if (m_bFirstTime)
	{
		for (int i=0; i<m_aCtrls.GetSize(); i++)
			if (!m_aCtrls[i].m_CWnd->CreateEx(m_aCtrls[i].m_dwExStyle, m_aCtrls[i].m_strClass,
							  m_aCtrls[i].m_strCaption,
							  WS_CHILD | WS_VISIBLE | m_aCtrls[i].m_dwStyle,
							  m_aCtrls[i].m_ControlRect,
							  this,
							  m_aCtrls[i].m_id) )
				return false;
	}
	
	m_bFirstTime = false;

	//TODO: add ur own controll modification here

	::SendMessage(GetParent()->m_hWnd,WCM_RESIZEWND,(WPARAM)GetWindowLong(m_hWnd,GWL_ID),
												   (LPARAM)m_hWnd);

	return true;
}

void CWndCtrl::DestroyControls()
{
	::SendMessage(GetParent()->m_hWnd,WCM_RESIZEWND,(WPARAM)GetWindowLong(m_hWnd,GWL_ID),
												   (LPARAM)m_hWnd);

/*	for (int i=0; i<=m_sCWnd.topCtrl; i++)
		m_sCWnd.m_CWnd[i]->DestroyWindow();
*/
}

RECT CWndCtrl::RepositionWindow(int x, int y)
{
	
	RECT rect, oldRect;
	int xOffset = 0, yOffset = 0;

	GetWindowRect(&rect);
	GetParent()->ScreenToClient(&rect);

	oldRect = rect;
	
	xOffset = x - rect.left;
	yOffset = y - rect.top ;

	rect.top = y;
	rect.left = x;
	rect.bottom += yOffset;
	rect.right += xOffset;

	xOffset = x - oldWp.rcNormalPosition.left;
	yOffset = y - oldWp.rcNormalPosition.top ;

	oldWp.rcNormalPosition.top = y;
	oldWp.rcNormalPosition.left = x;
	oldWp.rcNormalPosition.bottom += yOffset;
	oldWp.rcNormalPosition.right += xOffset;

	MoveWindow(&rect,TRUE);
	RedrawWindow();

	::SendMessage(GetParent()->m_hWnd,WCM_RESIZEWND,NULL,(LPARAM)m_hWnd);

	return oldRect;
}

void CWndCtrl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if ( point.x <= 40 && point.y <=18 && m_bExistControl)
	{
		m_hCursor = AfxGetApp()->LoadCursor(IDC_POINTINGHAND);
		m_hPrevCursor = SetCursor(m_hCursor);
	}

	else if ( point.x <= 40 && point.y <=18 && !m_bExistControl)
	{
		m_hCursor = AfxGetApp()->LoadCursor(IDC_POINTINGHAND_NOTALLOWED);
		m_hPrevCursor = SetCursor(m_hCursor);
	}

	CWnd::OnLButtonUp(nFlags, point);
}

BOOL CWndCtrl::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	cs.cx = 150;//the default creation width of the control. [Closed State]
	cs.cy = 18; //the default creation height of the control. [Closed State]

	return CWnd::PreCreateWindow(cs);
}

bool CWndCtrl::GetOpenStatus()
{
	return m_bOpen;
}


void CWndCtrl::SetOpenHeight(int height)
{
	RECT rect;

	GetWindowRect(&rect);
	ScreenToClient(&rect);

	if (height < 24) { //minimum open height of WndCtrl
		m_bottom = 24;
		return;
	}
	m_bottom = rect.top + height;
}

int CWndCtrl::IncrementOpenHeight(int increment)
{
	int oldHeight;
	RECT rect;

	GetWindowRect(&rect);
	ScreenToClient(&rect);
	
	oldHeight = m_bottom - rect.top+1;

	m_bottom += increment;

	if ( m_bOpen )
	{
		WINDOWPLACEMENT wp;
		GetWindowPlacement(&wp);
		wp.rcNormalPosition.bottom = wp.rcNormalPosition.top + m_bottom;
		wp.rcNormalPosition.right = wp.rcNormalPosition.left + m_right;
		SetWindowPlacement(&wp);

		::SendMessage(GetParent()->m_hWnd,WCM_RESIZEWND,(WPARAM)GetWindowLong(m_hWnd,GWL_ID),
													   (LPARAM)m_hWnd);
	}

	return oldHeight;
}

void CWndCtrl::SetOpenWidth(int width)
{
	RECT rect;

	GetWindowRect(&rect);
	ScreenToClient(&rect);

	if (width < 150) { //minimum width of WndCtrl
		m_right = 150;
		return;
	}
	m_right = rect.left + width;
}

int CWndCtrl::IncrementOpenWidth(int increment)
{
	int oldWidth;
	RECT rect;

	GetWindowRect(&rect);
	ScreenToClient(&rect);
	
	oldWidth = m_right - rect.left+1;

	m_right += increment;

	if ( m_bOpen )
	{
		WINDOWPLACEMENT wp;
		GetWindowPlacement(&wp);
		wp.rcNormalPosition.bottom = wp.rcNormalPosition.top + m_bottom;
		wp.rcNormalPosition.right = wp.rcNormalPosition.left + m_right;
		SetWindowPlacement(&wp);

		::SendMessage(GetParent()->m_hWnd,WCM_RESIZEWND,(WPARAM)GetWindowLong(m_hWnd,GWL_ID),
													   (LPARAM)m_hWnd);
	}

	return oldWidth;
}

HBRUSH CWndCtrl::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CWnd::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	if ( *pWnd == m_Title || nCtlColor == CTLCOLOR_STATIC)
	{
		pDC->SetBkMode(TRANSPARENT);
		hbr = m_titleBrush;
	}

	// TODO: Return a different brush if the default is not desired
	return hbr;
}

CFont* CWndCtrl::GetTitleFont()
{
	return &m_font;
}

void CWndCtrl::SetTitleFont(int pointSize, CString faceName)
{
	m_font.DeleteObject();
	m_font.CreatePointFont(pointSize,faceName);
}

HBRUSH CWndCtrl::GetTitleBrush()
{
	return m_titleBrush;
}

HBRUSH CWndCtrl::SetTitleBrush(HBRUSH brush)
{
	HBRUSH oldBrush = m_titleBrush;

	m_titleBrush = brush;

	return oldBrush;
}

HBRUSH CWndCtrl::CreateTitleBrush(UINT Red, UINT Green, UINT Blue)
{
	HBRUSH oldBrush = m_titleBrush;

	m_titleBrush = CreateSolidBrush(RGB(Red,Green,Blue));

	return oldBrush;
}

BOOL CWndCtrl::Create(CString title, DWORD dwStyle, DWORD dwExStyle, int x, int y, CWnd* pParent, UINT id)
{
	return CWnd::CreateEx(dwExStyle,
  						  NULL, //default CWnd class
						  title,
						  dwStyle,
						  CRect(x,y,0,0),
						  pParent,
						  id);
}

void CWndCtrl::StopOpen()
{
	m_bStopOpen = true;
}

void CWndCtrl::StopClose()
{
	m_bStopClose = true;
}


void CWndCtrl::SetTitle(CString title)
{
	m_Title.SetWindowText(title);
}

void CWndCtrl::GetTitle(CString &title)
{
	m_Title.GetWindowText(title);
}

bool CWndCtrl::OpenWndCtrl(bool bOpen)
{
	if ( (GetOpenStatus() && !bOpen) || (!GetOpenStatus() && bOpen) )
	{
		SendMessage(WM_LBUTTONDOWN, 0, MAKELPARAM(10,10));
		return true;
	}
	return false;
}


void CWndCtrl::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if ( point.x>40 && point.x<150 && point.y>0 && point.y<20)
	{
		CPoint pt(point); ClientToScreen(&pt);
		CMenu wcMenu;
		wcMenu.CreatePopupMenu();
		wcMenu.AppendMenu(MF_STRING, IDM_OPEN, "Open");
		wcMenu.AppendMenu(MF_STRING, IDM_CLOSE, "Close");
		if ( GetOpenStatus() )
			wcMenu.EnableMenuItem(0, MF_GRAYED|MF_BYPOSITION);
		else
			wcMenu.EnableMenuItem(1, MF_GRAYED|MF_BYPOSITION);

		if ( !m_bExistControl )
			wcMenu.EnableMenuItem(0, MF_GRAYED|MF_BYPOSITION);

		if ( m_aMenuItems.GetSize() )
		{
			wcMenu.AppendMenu(MF_SEPARATOR);
			for (int i=0; i<m_aMenuItems.GetSize(); i++ )
			{
				sMenu tempMenu = m_aMenuItems[i];
				wcMenu.AppendMenu(tempMenu.nFlags, tempMenu.nID_or_Handle, tempMenu.lpszMenuItem);
			}
		}

		wcMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, pt.x, pt.y, this);
	}
	
	CWnd::OnRButtonDblClk(nFlags, point);
}

void CWndCtrl::AddMenuItem(UINT nFlags, UINT iID_or_Handle, LPCTSTR strMenuItem)
{
	sMenu tempMenu;
	tempMenu.nFlags = nFlags;
	tempMenu.lpszMenuItem = strMenuItem;
	tempMenu.nID_or_Handle = iID_or_Handle;

	m_aMenuItems.Add(tempMenu);
}


void CWndCtrl::SetOpenWndCtrlStyle(DWORD dwStyle, DWORD dwExStyle)
{
	m_dwOpenStyle |= dwStyle;
	m_dwOpenExStyle = dwExStyle;
}

void CWndCtrl::GetOpenWndCtrlStyle(DWORD &dwStyle, DWORD &dwExStyle)
{
	dwStyle = m_dwOpenStyle;
	dwExStyle = m_dwOpenExStyle;
}
