#if !defined(AFX_WNDCTRL_H__529044BC_5174_11D4_ABE9_00D0B7197955__INCLUDED_)
#define AFX_WNDCTRL_H__529044BC_5174_11D4_ABE9_00D0B7197955__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WndCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CWndCtrl window

#define EXPAND 0
#define CONTRACT 1

#define IDM_OPEN 0x0737
#define IDM_CLOSE 0x0747

#define WCM_RESIZEWND WM_USER+1
/*
	Local message
	
	LOWORD(wParam) is the id of the WndCtrl
	lParam is the handle to the WndCtrl
*/

#define WCM_OPENING WM_USER+2
/*
	local message

	signals that the WndCtrl is about to open
	LOWORD(wParam) is the id of the WndCtrl
	lParam is the handle to the WndCtrl
*/

#define WCM_OPEN WM_USER+3
/*
	local message

	signals that the WndCtrl has opened
	LOWORD(wParam) is the id of the WndCtrl
	lParam is the handle to the WndCtrl
*/

#define WCM_CLOSING WM_USER+4
/*
	local message

	signals that the WndCtrl is about to close
	LOWORD(wParam) is the id of the WndCtrl
	lParam is the handle to the WndCtrl
*/

#define WCM_CLOSED WM_USER+5
/*
	local message

	signals that the WndCtrl has closed
	LOWORD(wParam) is the id of the WndCtrl
	lParam is the handle to the WndCtrl
*/



class CWndCtrl : public CWnd
{
// Construction
public:
	CWndCtrl();

// Attributes
private:
struct sCWnd {
	CWnd* m_CWnd;

	RECT m_ControlRect;
	DWORD m_dwStyle;
	UINT m_id;
	CString m_strClass;
	CString m_strCaption;
	DWORD m_dwExStyle;
};
struct sMenu {
	UINT nFlags;
	UINT nID_or_Handle;
	LPCTSTR lpszMenuItem;
};

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWndCtrl)
	protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	void GetOpenWndCtrlStyle(DWORD& dwStyle, DWORD& dwExStyle);
	void SetOpenWndCtrlStyle(DWORD dwStyle, DWORD dwExStyle);
	UINT GetControl(CWnd& cWnd);
	void AddMenuItem(UINT nFlags, UINT iMenuItemID, LPCTSTR strMenuItemText);
	void GetTitle(CString& title);
	bool OpenWndCtrl(bool bOpen = TRUE);
	void SetTitle(CString title);
	void StopClose();
	virtual BOOL Create(CString title, DWORD dwStyle, DWORD dwExStyle, int x, int y, CWnd* pParent, UINT id);
	int IncrementOpenWidth(int increment);
	int IncrementOpenHeight(int increment);
	HBRUSH CreateTitleBrush(UINT Red, UINT Green, UINT Blue);
	HBRUSH SetTitleBrush(HBRUSH brush);
	HBRUSH GetTitleBrush();
	CFont* GetTitleFont();
	void SetTitleFont(int pointSize, CString faceName);
	void StopOpen();
	void SetOpenWidth(int width);
	void SetOpenHeight(int height);
	bool GetOpenStatus();
	RECT RepositionWindow(int x, int y);
	void AddControl(CWnd *cwnd, CRect rect, CString strClass, CString strCaption, DWORD dwStyle, DWORD dwExStyle, UINT id);
	CWnd* GetControl(UINT ctrlID);
	virtual ~CWndCtrl();

	// Generated message map functions
protected:
	//{{AFX_MSG(CWndCtrl)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	DWORD m_dwOpenExStyle;
	DWORD m_dwOpenStyle;
	bool m_bFirstTime;
	bool m_bStopClose;
	bool m_bStopOpen;
	HBRUSH m_titleBrush;
	CFont m_font;
	int m_right;
	DWORD oldWord;
	int m_bottom;
	WINDOWPLACEMENT oldWp;
	bool m_bOpen;
	bool m_bExistControl;
	void DestroyControls();
	bool DrawControls();
	CArray<sCWnd,const sCWnd> m_aCtrls;
	CArray<sMenu,const sMenu> m_aMenuItems;
	HCURSOR m_hPrevCursor;
	HCURSOR m_hCursor;
	CStatic m_Open;
	CStatic m_Title;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WNDCTRL_H__529044BC_5174_11D4_ABE9_00D0B7197955__INCLUDED_)
